
# Get complete path to perl5
#

print "$0: Checking for perl5\n";
chop($PERL = `which $^X`);

$done = 0;
do {
  while (!((-f "$PERL") && (-x "$PERL") && ($PERL =~ /^\//))) {
    print "\n\nEnter complete path to perl5 --> ";
    chop($PERL = <STDIN>);
  }
  $version = `$PERL -v`;
  $version =~ /version (\S+)/;
  $version = $1;
  if ($version >= 5.0) {
    $done = 1;
  } else {
    print "$PERL must be version 5.0 or better.\nIf you experience problems, check your Perl version with perl -v.\n";
    $done = 1;
  }
} while (!$done);

#
# Create executables
#

$INSTALL_DIR    = $ARGV[1];
unless ($INSTALL_DIR =~ /^\//) {
  chop($INSTALL_DIR = `pwd`) || die;
}
$DEFAULT_SERVER = $ARGV[0];

print "$0: Creating comms\n";  
open(handle, ">bin/comms");
print handle "#!/bin/sh\n";
print handle "TCL_LIBRARY=$INSTALL_DIR/lib/tcl7.4; export TCL_LIBRARY\n";
print handle "TK_LIBRARY=$INSTALL_DIR/lib/tk4.0; export TK_LIBRARY\n"; 
print handle "INSTALL_DIR=$INSTALL_DIR; export INSTALL_DIR\n";
print handle "CACHE_HOME=\$HOME; export CACHE_HOME\n";
print handle "echo \"comms: downloading comms-1.0.tk\"\n";
print handle "if\n";
print handle "  ($PERL $INSTALL_DIR/bin/client.pl -file /tmp/comms-\$\$ -request comms-1.0.tk -server $DEFAULT_SERVER \$\@)\n";
print handle "then\n";
print handle "echo \"comms: starting comms-1.0.tk\"\n";
print handle "  (wish -f /tmp/comms-\$\$ $PERL)\n";
print handle "fi\n";
print handle "rm -f /tmp/comms-\$\$\n";
print handle "rm -f \$CACHE_HOME/.comms/lock\n";
print handle "echo \"comms: exited\"\n";
close(handle);
system("chmod +x bin/comms");

print "$0: Creating comms-daemon\n";  
open(handle, ">bin/comms-daemon");
print handle "#!/bin/sh\n";
print handle "INSTALL_DIR=$INSTALL_DIR; export INSTALL_DIR\n";
print handle "echo \"comms-daemon: downloading comms-daemon-1.0.pl\"\n";
print handle "if\n";
print handle "  ($PERL $INSTALL_DIR/bin/client.pl -file /tmp/comms-daemon-\$\$ -request comms-daemon-1.0.pl -server $DEFAULT_SERVER \$\@)\n";
print handle "then\n";
print handle "echo \"comms-daemon: starting comms-daemon-1.0.pl\"\n";
print handle "  ($PERL /tmp/comms-daemon-\$\$ \$\@)\n";
print handle "fi\n";
print handle "rm -f /tmp/comms-daemon-\$\$\n";
print handle "echo \"comms-daemon: exited\"\n";
close(handle);
system("chmod +x bin/comms-daemon");

print "$0: Creating submit\n";  
open(handle, ">bin/submit");
print handle "#!/bin/sh\n";
print handle "INSTALL_DIR=$INSTALL_DIR; export INSTALL_DIR\n";
print handle "TCL_LIBRARY=$INSTALL_DIR/lib/tcl7.4; export TCL_LIBRARY\n";
print handle "TK_LIBRARY=$INSTALL_DIR/lib/tk4.0; export TK_LIBRARY\n";
print handle "echo \"submit: downloading submit-1.0.tk\"\n";
print handle "if\n";
print handle "  ($PERL $INSTALL_DIR/bin/client.pl -file /tmp/submit-\$\$ -request submit-1.0.tk -server $DEFAULT_SERVER \$\@)\n";
print handle "then\n";
print handle "echo \"submit: starting submit-1.0.tk\"\n";
print handle "  (wish -f /tmp/submit-\$\$ $PERL)\n";
print handle "fi\n";
print handle "rm -f /tmp/submit-\$\$*\n";
print handle "rm -f \$HOME/.submit/lock\n";
print handle "echo \"submit: exited\"\n";
close(handle);
system("chmod +x bin/submit");

print "$0: Installation complete\n\n";  
print "***************************************************************\n"; 
print "* Execute bin/submit to start the Submission Tool.            *\n";  
print "* Execute bin/comms to start the Communications Package.      *\n";  
print "***************************************************************\n\n";
